#==============================================================================
#
#  $Id$
#
"""
   The player object.
"""
#
#  Copyright (C) 2007 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

import wurld, util, debug
player = wurld.createMoveable()
playerCollidable = wurld.createSphereCollidable(player, 2)
player.addCollidable(playerCollidable)
origin = wurld.createVector(0, 18, 0)
player.setPosition(origin)

engine = wurld.getGameEngine()
engine.setPlayer(player)
engine.addCollidable(playerCollidable)

def teleport(key):
   player.setPosition(origin)

util.bindKey(ord('0'), teleport)

# debug code
def onCollision():
   print 'got player collision'
#playerPythonObject = wurld.createPythonObject()
#playerPythonObject.setCollisionCallback(onCollision)

#tracer = debug.TeleportTracer(player)
#tracer.obj.setMoveable(tracer.moveable)
#tracer.obj.setCollisionCallback(onCollision)
#playerPythonObject.setMoveable(player)
#player.enableTrace(True)
